#ifndef INCLUDE_H_ACTIONLISTENER
#define INCLUDE_H_ACTIONLISTENER

#include "FileInfo.hpp"
#include "SettingInfo.hpp"

#include "tstring.hpp"

#include "ActionInvoker.hpp"
#include "EventListener.hpp"

/*!
 * EventListenert@CCxg󂯎AActionInvokerN܂B
 */
class ActionListener : public virtual EventListener
{
private:
	ActionListener( const ActionListener& ); //<! Ȃ
	operator=( const ActionListener& ); //<! Ȃ

public:
	ActionListener( const ActionSettingInfo& v_settingInfo );
	virtual ~ActionListener() throw();

	virtual void sweepEvent() throw();
	virtual bool isEventListenerAvailable() const throw();

	virtual void notifyFileEvent( DWORD v_eventId, const tstring& v_absolutePath, const FileInfo& v_fileInfo ) throw();
	virtual void notifyEvent( DWORD v_eventId ) throw();

	virtual tstring getDescription() const throw();

private:
	ActionInvokerPtr pActionInvoker_;
	const unsigned int maxProcess_;
	unsigned int processCount_;
};

#endif
